// *********************************************************
//
// File autogenerated for the rosparam_handler package
// by the rosparam_handler package.
// Please do not edit.
//
// ********************************************************/

#pragma once

#include <ros/param.h>
#include <ros/node_handle.h>
#include <rosparam_handler/utilities.hpp>
#ifdef DYNAMIC_RECONFIGURE_FOUND
#include <rosparam_handler/DefaultsConfig.h>
#else
struct DefaultsConfig{};
#endif


namespace rosparam_handler {

/// \brief Parameter struct generated by rosparam_handler
struct DefaultsParameters {

  using Config = DefaultsConfig;

  DefaultsParameters(const ros::NodeHandle& private_node_handle)
  : globalNamespace{"/"},
    privateNamespace{private_node_handle.getNamespace() + "/"},
    nodeName{rosparam_handler::getNodeName(private_node_handle)} {}

  /// \brief Get values from parameter server
  /// 
  /// Will fail if a value can not be found and no default value is given.
  void fromParamServer(){
    bool success = true;
    success &= rosparam_handler::getParam(privateNamespace + "int_param_w_default", int_param_w_default, int{1});
    success &= rosparam_handler::getParam(privateNamespace + "double_param_w_default", double_param_w_default, double{1.1});
    success &= rosparam_handler::getParam(privateNamespace + "str_param_w_default", str_param_w_default, std::string{"Hello World"});
    success &= rosparam_handler::getParam(privateNamespace + "bool_param_w_default", bool_param_w_default, bool{true});
    success &= rosparam_handler::getParam(privateNamespace + "vector_int_param_w_default", vector_int_param_w_default, std::vector<int>{1,2,3});
    success &= rosparam_handler::getParam(privateNamespace + "vector_double_param_w_default", vector_double_param_w_default, std::vector<double>{1.1,1.2,1.3});
    success &= rosparam_handler::getParam(privateNamespace + "vector_bool_param_w_default", vector_bool_param_w_default, std::vector<bool>{false,true});
    success &= rosparam_handler::getParam(privateNamespace + "vector_string_param_w_default", vector_string_param_w_default, std::vector<std::string>{"Hello","World"});
    success &= rosparam_handler::getParam(privateNamespace + "map_param_w_default", map_param_w_default, std::map<std::string,std::string>{{"Hello","World"}});
    success &= rosparam_handler::getParam(privateNamespace + "enum_param_w_default", enum_param_w_default, int{1});
    rosparam_handler::testConstParam(privateNamespace + "enum_param_w_default_Small");
    rosparam_handler::testConstParam(privateNamespace + "enum_param_w_default_Medium");
    rosparam_handler::testConstParam(privateNamespace + "enum_param_w_default_Large");
    rosparam_handler::testConstParam(privateNamespace + "enum_param_w_default_ExtraLarge");

    if(!success){
      missingParamsWarning();
      rosparam_handler::exit("RosparamHandler: GetParam could net retrieve parameter.");
    }
    ROS_DEBUG_STREAM(*this);
  }

  /// \brief Set parameters on ROS parameter server.
  void toParamServer(){
  rosparam_handler::setParam(privateNamespace + "int_param_w_default",int_param_w_default);
  rosparam_handler::setParam(privateNamespace + "double_param_w_default",double_param_w_default);
  rosparam_handler::setParam(privateNamespace + "str_param_w_default",str_param_w_default);
  rosparam_handler::setParam(privateNamespace + "bool_param_w_default",bool_param_w_default);
  rosparam_handler::setParam(privateNamespace + "vector_int_param_w_default",vector_int_param_w_default);
  rosparam_handler::setParam(privateNamespace + "vector_double_param_w_default",vector_double_param_w_default);
  rosparam_handler::setParam(privateNamespace + "vector_bool_param_w_default",vector_bool_param_w_default);
  rosparam_handler::setParam(privateNamespace + "vector_string_param_w_default",vector_string_param_w_default);
  rosparam_handler::setParam(privateNamespace + "map_param_w_default",map_param_w_default);
  rosparam_handler::setParam(privateNamespace + "enum_param_w_default",enum_param_w_default);        
  }

  /// \brief Update configurable parameters.
  ///
  /// \param config  dynamic reconfigure struct
  /// \level ?
  void fromConfig(const Config& config, const uint32_t level = 0){
#ifdef DYNAMIC_RECONFIGURE_FOUND
    int_param_w_default = config.int_param_w_default;
    double_param_w_default = config.double_param_w_default;
    str_param_w_default = config.str_param_w_default;
    bool_param_w_default = config.bool_param_w_default;
    enum_param_w_default = config.enum_param_w_default;
#else
  ROS_FATAL_STREAM("dynamic_reconfigure was not found during compilation. So fromConfig() is not available. Please recompile with dynamic_reconfigure.");
  rosparam_handler::exit("dynamic_reconfigure was not found during compilation. So fromConfig() is not available. Please recompile with dynamic_reconfigure.");
#endif
  }

  void toConfig(Config& config){
#ifdef DYNAMIC_RECONFIGURE_FOUND
       config.int_param_w_default = int_param_w_default;
   config.double_param_w_default = double_param_w_default;
   config.str_param_w_default = str_param_w_default;
   config.bool_param_w_default = bool_param_w_default;
   config.enum_param_w_default = enum_param_w_default;
#else
      ROS_FATAL_STREAM("dynamic_reconfigure was not found during compilation. So toConfig() is not available. Please recompile with dynamic_reconfigure.");
      rosparam_handler::exit("dynamic_reconfigure was not found during compilation. So toConfig() is not available. Please recompile with dynamic_reconfigure.");
#endif
  }

  /// \brief Stream operator for printing parameter struct
  friend std::ostream& operator<<(std::ostream& os, const DefaultsParameters& p)
  {
    os << "[" << p.nodeName << "]\nNode " << p.nodeName << " has the following parameters:\n"
      << "	" << p.privateNamespace << "int_param_w_default:" << p.int_param_w_default << "\n"
      << "	" << p.privateNamespace << "double_param_w_default:" << p.double_param_w_default << "\n"
      << "	" << p.privateNamespace << "str_param_w_default:" << p.str_param_w_default << "\n"
      << "	" << p.privateNamespace << "bool_param_w_default:" << p.bool_param_w_default << "\n"
      << "	" << p.privateNamespace << "vector_int_param_w_default:" << rosparam_handler::to_string(p.vector_int_param_w_default) << "\n"
      << "	" << p.privateNamespace << "vector_double_param_w_default:" << rosparam_handler::to_string(p.vector_double_param_w_default) << "\n"
      << "	" << p.privateNamespace << "vector_bool_param_w_default:" << rosparam_handler::to_string(p.vector_bool_param_w_default) << "\n"
      << "	" << p.privateNamespace << "vector_string_param_w_default:" << rosparam_handler::to_string(p.vector_string_param_w_default) << "\n"
      << "	" << p.privateNamespace << "map_param_w_default:" << rosparam_handler::to_string(p.map_param_w_default) << "\n"
      << "	" << p.privateNamespace << "enum_param_w_default:" << p.enum_param_w_default << "\n"
      << "	" << p.privateNamespace << "enum_param_w_default_Small:" << p.enum_param_w_default_Small << "\n"
      << "	" << p.privateNamespace << "enum_param_w_default_Medium:" << p.enum_param_w_default_Medium << "\n"
      << "	" << p.privateNamespace << "enum_param_w_default_Large:" << p.enum_param_w_default_Large << "\n"
      << "	" << p.privateNamespace << "enum_param_w_default_ExtraLarge:" << p.enum_param_w_default_ExtraLarge << "\n"
;
    return os;
  }

    int int_param_w_default; /*!< An Integer parameter */
  double double_param_w_default; /*!< A double parameter */
  std::string str_param_w_default; /*!< A string parameter */
  bool bool_param_w_default; /*!< A Boolean parameter */
  std::vector<int> vector_int_param_w_default; /*!< A vector of int parameter */
  std::vector<double> vector_double_param_w_default; /*!< A vector of double parameter */
  std::vector<bool> vector_bool_param_w_default; /*!< A vector of bool parameter */
  std::vector<std::string> vector_string_param_w_default; /*!< A vector of string parameter */
  std::map<std::string,std::string> map_param_w_default; /*!< A map parameter */
  int enum_param_w_default; /*!< enum */
  static constexpr auto enum_param_w_default_Small = 0; /*!< Constant for enum enum_param_w_default */
  static constexpr auto enum_param_w_default_Medium = 1; /*!< Constant for enum enum_param_w_default */
  static constexpr auto enum_param_w_default_Large = 2; /*!< Constant for enum enum_param_w_default */
  static constexpr auto enum_param_w_default_ExtraLarge = 3; /*!< Constant for enum enum_param_w_default */

private:
  /// \brief Issue a warning about missing default parameters.
  void missingParamsWarning(){
    ROS_WARN_STREAM("[" << nodeName << "]\nThe following parameters do not have default values and need to be specified:\n"
    );
  }

  const std::string globalNamespace;
  const std::string privateNamespace;
  const std::string nodeName;
};

} // namespace rosparam_handler
