// *********************************************************
//
// File autogenerated for the rosparam_handler package
// by the rosparam_handler package.
// Please do not edit.
//
// ********************************************************/

#pragma once

#include <ros/param.h>
#include <ros/node_handle.h>
#include <rosparam_handler/utilities.hpp>
#ifdef DYNAMIC_RECONFIGURE_FOUND
#include <rosparam_handler/MinMaxConfig.h>
#else
struct MinMaxConfig{};
#endif


namespace rosparam_handler {

/// \brief Parameter struct generated by rosparam_handler
struct MinMaxParameters {

  using Config = MinMaxConfig;

  MinMaxParameters(const ros::NodeHandle& private_node_handle)
  : globalNamespace{"/"},
    privateNamespace{private_node_handle.getNamespace() + "/"},
    nodeName{rosparam_handler::getNodeName(private_node_handle)} {}

  /// \brief Get values from parameter server
  /// 
  /// Will fail if a value can not be found and no default value is given.
  void fromParamServer(){
    bool success = true;
    success &= rosparam_handler::getParam(privateNamespace + "int_param_w_minmax", int_param_w_minmax, int{3});
    success &= rosparam_handler::getParam(privateNamespace + "double_param_w_minmax", double_param_w_minmax, double{3.1});
    success &= rosparam_handler::getParam(privateNamespace + "vector_int_param_w_minmax", vector_int_param_w_minmax, std::vector<int>{-1,2,3});
    success &= rosparam_handler::getParam(privateNamespace + "vector_double_param_w_minmax", vector_double_param_w_minmax, std::vector<double>{-1.1,1.2,2.3});
    success &= rosparam_handler::getParam(privateNamespace + "map_param_w_minmax", map_param_w_minmax, std::map<std::string,double>{{"value3",2.2},{"value2",1.2},{"value1",-1.2}});
    rosparam_handler::testMin<int>(privateNamespace + "int_param_w_minmax", int_param_w_minmax, 0);
    rosparam_handler::testMax<int>(privateNamespace + "int_param_w_minmax", int_param_w_minmax, 2);
    rosparam_handler::testMin<double>(privateNamespace + "double_param_w_minmax", double_param_w_minmax, 0.0);
    rosparam_handler::testMax<double>(privateNamespace + "double_param_w_minmax", double_param_w_minmax, 2.0);
    rosparam_handler::testMin<int>(privateNamespace + "vector_int_param_w_minmax", vector_int_param_w_minmax, 0);
    rosparam_handler::testMax<int>(privateNamespace + "vector_int_param_w_minmax", vector_int_param_w_minmax, 2);
    rosparam_handler::testMin<double>(privateNamespace + "vector_double_param_w_minmax", vector_double_param_w_minmax, 0.0);
    rosparam_handler::testMax<double>(privateNamespace + "vector_double_param_w_minmax", vector_double_param_w_minmax, 2.0);
    rosparam_handler::testMin<std::string,double>(privateNamespace + "map_param_w_minmax", map_param_w_minmax, 0.0);
    rosparam_handler::testMax<std::string,double>(privateNamespace + "map_param_w_minmax", map_param_w_minmax, 2.0);
    if(!success){
      missingParamsWarning();
      rosparam_handler::exit("RosparamHandler: GetParam could net retrieve parameter.");
    }
    ROS_DEBUG_STREAM(*this);
  }

  /// \brief Set parameters on ROS parameter server.
  void toParamServer(){
  rosparam_handler::setParam(privateNamespace + "int_param_w_minmax",int_param_w_minmax);
  rosparam_handler::setParam(privateNamespace + "double_param_w_minmax",double_param_w_minmax);
  rosparam_handler::setParam(privateNamespace + "vector_int_param_w_minmax",vector_int_param_w_minmax);
  rosparam_handler::setParam(privateNamespace + "vector_double_param_w_minmax",vector_double_param_w_minmax);
  rosparam_handler::setParam(privateNamespace + "map_param_w_minmax",map_param_w_minmax);        
  }

  /// \brief Update configurable parameters.
  ///
  /// \param config  dynamic reconfigure struct
  /// \level ?
  void fromConfig(const Config& config, const uint32_t level = 0){
#ifdef DYNAMIC_RECONFIGURE_FOUND

#else
  ROS_FATAL_STREAM("dynamic_reconfigure was not found during compilation. So fromConfig() is not available. Please recompile with dynamic_reconfigure.");
  rosparam_handler::exit("dynamic_reconfigure was not found during compilation. So fromConfig() is not available. Please recompile with dynamic_reconfigure.");
#endif
  }

  void toConfig(Config& config){
#ifdef DYNAMIC_RECONFIGURE_FOUND
    
#else
      ROS_FATAL_STREAM("dynamic_reconfigure was not found during compilation. So toConfig() is not available. Please recompile with dynamic_reconfigure.");
      rosparam_handler::exit("dynamic_reconfigure was not found during compilation. So toConfig() is not available. Please recompile with dynamic_reconfigure.");
#endif
  }

  /// \brief Stream operator for printing parameter struct
  friend std::ostream& operator<<(std::ostream& os, const MinMaxParameters& p)
  {
    os << "[" << p.nodeName << "]\nNode " << p.nodeName << " has the following parameters:\n"
      << "	" << p.privateNamespace << "int_param_w_minmax:" << p.int_param_w_minmax << "\n"
      << "	" << p.privateNamespace << "double_param_w_minmax:" << p.double_param_w_minmax << "\n"
      << "	" << p.privateNamespace << "vector_int_param_w_minmax:" << rosparam_handler::to_string(p.vector_int_param_w_minmax) << "\n"
      << "	" << p.privateNamespace << "vector_double_param_w_minmax:" << rosparam_handler::to_string(p.vector_double_param_w_minmax) << "\n"
      << "	" << p.privateNamespace << "map_param_w_minmax:" << rosparam_handler::to_string(p.map_param_w_minmax) << "\n"
;
    return os;
  }

    int int_param_w_minmax; /*!< An Integer parameter */
  double double_param_w_minmax; /*!< A double parameter */
  std::vector<int> vector_int_param_w_minmax; /*!< A vector of int parameter */
  std::vector<double> vector_double_param_w_minmax; /*!< A vector of double parameter */
  std::map<std::string,double> map_param_w_minmax; /*!< A map parameter */

private:
  /// \brief Issue a warning about missing default parameters.
  void missingParamsWarning(){
    ROS_WARN_STREAM("[" << nodeName << "]\nThe following parameters do not have default values and need to be specified:\n"
    );
  }

  const std::string globalNamespace;
  const std::string privateNamespace;
  const std::string nodeName;
};

} // namespace rosparam_handler
